#extension GL_ARB_texture_rectangle : enable

uniform sampler2DRect brain;

const int OFF=0;
const int ON=1;
const int DEAD=2;

const vec4 offColour=vec4(0,0,0,0);
const vec4 onColour=vec4(0.9,0.9,0.9,0);
const vec4 deadColour=vec4(1,0,0,0);

void main()
{
  float state=texelFetch(brain,ivec2(gl_FragCoord)).r;

  vec4 colour;
  switch(state) {
  case OFF:
    colour=offColour;
    break;
  case ON:
    colour=onColour;
    break;
  case DEAD:
    colour=deadColour;
    break;
  }

  gl_FragColor=colour;

/*  ivec2 pos=ivec2(gl_FragCoord);
  int numNeighbours=0;
  int newState;
  
  switch(state) {
  case OFF:
    if(texelFetch(brain,ivec2(pos.x-1,pos.y-1)).r==ON) {
      numNeighbours++;
    }
    if(texelFetch(brain,ivec2(pos.x-1,pos.y)).r==ON) {
      numNeighbours++;
    }
    if(texelFetch(brain,ivec2(pos.x-1,pos.y+1)).r==ON) {
      numNeighbours++;
    }
    if(texelFetch(brain,ivec2(pos.x,pos.y-1)).r==ON) {
      numNeighbours++;
    }
    if(texelFetch(brain,ivec2(pos.x,pos.y+1)).r==ON) {
      numNeighbours++;
    }
    if(texelFetch(brain,ivec2(pos.x+1,pos.y-1)).r==ON) {
      numNeighbours++;
    }
    if(texelFetch(brain,ivec2(pos.x+1,pos.y)).r==ON) {
      numNeighbours++;
    }
    if(texelFetch(brain,ivec2(pos.x+1,pos.y+1)).r==ON) {
      numNeighbours++;
    }
    if(numNeighbours==2) {
      newState=ON;
    } else {
      newState=OFF;
    }
    break;
  case ON:
    newState=DEAD;
    break;
  case DEAD:
    newState=OFF;
    break;
  }

  gl_FragColor=vec4(state/10.0,numNeighbours/10.0,newState/10.0,0);*/
}
