#ifndef RESOURCE_H
#define RESOURCE_H

#include "GLTB/referencedobject.h"

namespace GL3Support {
	class Resource : public gltb::ReferencedObject {
	public:
		enum Type {
			ShaderResource,
			TextureResource,
			VertexBufferResource
		};

		virtual Type getResourceType() = 0;
		virtual void reload() = 0;
	};
}

#endif
