
find_path(ICU_INCLUDE_DIR
  NAMES unicode/utypes.h
  HINTS /usr/include/
)

message(STATUS "ICU include directory: ${ICU_INCLUDE_DIR}")

find_path(ICU_LIB_BASE_DIR
  NAMES libicuuc.so libicudata.so
  HINTS /usr/lib
	/usr/lib64
	/usr/lib32
)

message(STATUS "ICU library directory: ${ICU_LIB_BASE_DIR}")

if(ICU_LIB_BASE_DIR-NOTFOUND)
else()
	set(ICU_LIBRARIES "${ICU_LIB_BASE_DIR}/libicudata.so" "${ICU_LIB_BASE_DIR}/libicuuc.so")
	message(STATUS "ICU libraries: ${ICU_LIBRARIES}")
endif()
