/*
 * glenums.h
 *
 *  Created on: Jul 24, 2010
 *      Author: gregor
 */

#ifndef GLENUMS_H_
#define GLENUMS_H_

namespace GL3Support {
	enum DepthTest {
		Less=GL_LESS,
		LessOrEqual=GL_LEQUAL,
		Greater=GL_GREATER,
		GreaterOrEqual=GL_GEQUAL,
		Equal=GL_EQUAL
	};

	enum BlendFunction {
		One = GL_ONE,
		Zero = GL_ZERO,
		SourceColour = GL_SRC_COLOR,
		DestinationColour = GL_DST_COLOR,
		OneMinusSourceColour = GL_ONE_MINUS_SRC_COLOR,
		OneMinusDestinationColour = GL_ONE_MINUS_DST_COLOR,
		SourceAlpha = GL_SRC_ALPHA,
		DestinationAlpha = GL_DST_ALPHA,
		OneMinusSourceAlpha = GL_ONE_MINUS_SRC_ALPHA,
		OneMinusDestinationAlpha = GL_ONE_MINUS_DST_ALPHA
	};

	enum FaceCulling {
		FrontFace=GL_FRONT,
		BackFace=GL_BACK
	};
}

#endif /* GLENUMS_H_ */
